<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" content="width=device-width, initial-scale=1.0">
    <title>User-order</title>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>

    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<body>

    <div class="container">
        <h2>Responsive Form</h2>
        <p>sample forms 02: multi colums</p>

        <form action="" class="jumbotron container" id="input-form">
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="fname">full name</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="ipt-fullname" name="full name" placeholder="Họ và tên.."
                        class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="lname">Email</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="inp-email" name="email" placeholder="email.." class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="fname">phone</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="ipt-phone" name="phone" placeholder="Số điện thoại.." class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="lname">Address</label>
                </div>
                <div class="col-sm-9">
                    <input type="text" id="inp-address" name="address" placeholder="Địa chỉ.." class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="updateDate">Ngày tạo</label>
                </div>
                <div class="col-sm-9">
                    <input type="date" id="input-ngay-tao" name="newDate" placeholder="Ngày tạo" class="form-control">
                </div>
            </div>
            <div class="row form-group">
                <div class="col-sm-3">
                    <label for="updateDate">Ngày sửa</label>
                </div>
                <div class="col-sm-9">
                    <input type="date" id="input-updateDate" name="updateDate" placeholder="Update Date"
                        class="form-control">
                </div>
            </div>
            <div class="row pull-right">
                <div class="col-sm-12">
                    <input type="button" value="Send" class="btn btn-info" id="send-button">
                    <button id="delete_data" class="btn btn-danger">Delete Data</button>
                    <button id="delete_data_all" class="btn btn-danger">Delete All Data</button>
                </div>
            </div>
        </form>

        <table class="table table-bordered table-striped table-hover" id="user-table">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>full name</th>
                    <th>email</th>
                    <th>phone</th>
                    <th>address</th>
                    <th>create</th>
                    <th>update</th>
                    <th>order</th>
                </tr>
        </table>
    </div>

    <script>

        $(document).ready(function () {
            var gID = "";
            var gFORM_MODE_INSERT = "Insert";
            var gFORM_MODE_UPDATE = "Update";
            var gFormMode = gFORM_MODE_INSERT;

            var table = $("#user-table").DataTable({
                "columns": [
                    { "data": "id" },
                    { "data": "fullName"},
                    { "data": "email" },
                    { "data": "phone" },
                    { "data": "address"},
                    { "data": "created" },
                    { "data": "updated" },
                    { "data" : "order"}
                ]
            })

            $.ajax({
                url: "http://localhost:8080/users",
                type: "GET",
                dataType: "json",
                success: function (res) {
                    console.log(res);
                    table.clear();
                    table.rows.add(res);
                    table.draw();
                },
                error: function (err) {
                    console.log(err.response);
                }
            });



            $(document).on('click', "tr", function () {
                onBtnDetailClick(this);
            })

            $(document).on('click', "#delete_data", function () {
                onBtnDeleteClick(this);
            })

            $(document).on('click', "#delete_data_all", function () {
                onBtnAllDeleteClick(this);
            })

            $(document).on('click', "#send-button", function () {
                onBtnSaveDataClick(this)
            })

            function onBtnDetailClick(paramElement) {

                gFormMode = gFORM_MODE_UPDATE;
                var vRowSelected = $(paramElement).closest("tr");
                var vTable = $("#user-table").DataTable();
                var vDataRow = vTable.row(vRowSelected).data();
                gID = vDataRow.id;
                $.ajax({
                    url: "http://localhost:8080/users/" + gID,
                    type: 'GET',
                    success: function (res) {
                        console.log(res);
                        $("#ipt-fullname").val(res.fullName);
                        $("#inp-email").val(res.email);
                        $("#ipt-phone").val(res.phone);
                        $("#inp-address").val(res.address);
                        let vCreateDate = res.created.slice(6, 10) + "-" + res.created.slice(3.5) + res.created.slice(0, 2);
                        $("#input-ngay-tao").val(vCreateDate);
                        if (res.updated != null) {
                            let vUpdateDate = res.updated.slice(6, 10) + "-" + res.updated.slice(3.5) + res.updated.slice(0, 2);
                            $("#input-updateDate").val(vUpdateDate);
                        } else {
                            $("#input-updateDate").val("");
                        }

                    },
                    error: function (err) {
                        console.log(err.status)
                    }
                })
            }

            function onBtnSaveDataClick() {
                if (gFormMode === gFORM_MODE_UPDATE) {
                    let vObjectRequest = {
                        id: gID,
                        fullname: $("#ipt-fullname").val(),
                        email: $("#inp-email").val(),
                        phone: $("#ipt-phone").val(),
                        address: $("#inp-address").val(),
                    };

                    $.ajax({
                        url: "http://localhost:8080/update-users/" + gID,
                        contentType: "application/json; charset=UTF-8",
                        type: 'PUT',
                        dataType: "json",
                        data: JSON.stringify(vObjectRequest),
                        success: function (res) {
                            window.location.reload();
                        },
                        error: function (err) {
                            console.log(err.status)
                        }
                    })
                } else {
                    let vObjectRequest = {
                        id: gID,
                        fullname: $("#ipt-fullname").val(),
                        email: $("#inp-email").val(),
                        phone: $("#ipt-phone").val(),
                        address: $("#inp-address").val(),
                    }
                    $.ajax({
                        url: "http://localhost:8080/created-users/",
                        contentType: "application/json; Charset=UFT-8",
                        type: 'POST',
                        dataType: "json",
                        data: JSON.stringify(vObjectRequest),
                        success: function (res) {
                            window.location.reload();
                        },
                        error: function (err) {
                            console.log(err.status)
                        }
                    })
                }
            }

            function onBtnDeleteClick() {
                if (confirm("bạn có muốn xóa?") == true) {


                    $.ajax({
                        url: "http://localhost:8080/delete-users/" + gID,
                        type: "DELETE",
                        dataType: "json",
                        success: function (res) {
                            window.location.reload();
                        },
                        error: function (err) {
                            console.log(err.response);
                        }
                    })
                }
            }

            function onBtnAllDeleteClick() {
                if (confirm("bạn có muốn xóa hết toàn bộ danh sách users?") == true) {
                    $.ajax({
                        url: "http://localhost:8080/delete-users",
                        type: "DELETE",
                        dataType: "json",
                        success: function (res) {
                            window.location.reload();
                        },
                        error: function (err) {
                            console.log(err.response);
                        }
                    })
                }
            }


        });



    </script>
</body>

</html>